﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 캘린더 셀
    /// </summary>
    public class CalendarCell : DataGridViewTextBoxCell
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 편집 타입 - EditType

        /// <summary>
        /// 편집 타입
        /// </summary>
        public override Type EditType
        {
            get
            {
                return typeof(CalendarEditingControl);
            }
        }

        #endregion
        #region 값 타입 - ValueType

        /// <summary>
        /// 값 타입
        /// </summary>
        public override Type ValueType
        {
            get
            {
                return typeof(DateTime);
            }
        }

        #endregion
        #region 디폴트 신규 행 값 - DefaultNewRowValue

        /// <summary>
        /// 디폴트 신규 행 값
        /// </summary>
        public override object DefaultNewRowValue
        {
            get
            {
                return DateTime.Now;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - CalendarCell()

        /// <summary>
        /// 생성자
        /// </summary>
        public CalendarCell() : base()
        {
            this.Style.Format = "d";
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 편집 컨트롤 초기화 하기 - InitializeEditingControl(rowIndex, initialFormattedValue, dataGridViewCellStyle)

        /// <summary>
        /// 편집 컨트롤 초기화 하기
        /// </summary>
        /// <param name="rowIndex">행 인덱스</param>
        /// <param name="initialFormattedValue">초기 포맷 값</param>
        /// <param name="dataGridViewCellStyle">그리드 데이터 뷰 셀 스타일</param>
        public override void InitializeEditingControl(int rowIndex, object initialFormattedValue, DataGridViewCellStyle dataGridViewCellStyle)
        {
            base.InitializeEditingControl(rowIndex, initialFormattedValue, dataGridViewCellStyle);

            CalendarEditingControl control = DataGridView.EditingControl as CalendarEditingControl;


            if(this.Value == null)
            {
                control.Value = (DateTime)this.DefaultNewRowValue;
            }
            else
            {
                control.Value = (DateTime)this.Value;
            }
        }

        #endregion
    }
}