﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 캘린더 컬럼
    /// </summary>
    public class CalendarColumn : DataGridViewColumn
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 셀 템플리트 - CellTemplate

        /// <summary>
        /// 셀 템플리트
        /// </summary>
        public override DataGridViewCell CellTemplate
        {
            get
            {
                return base.CellTemplate;
            }
            set
            {
                if(value != null &&  !value.GetType().IsAssignableFrom(typeof(CalendarCell)))
                {
                    throw new InvalidCastException("CalendarCell 타입이어야 합니다.");
                }

                base.CellTemplate = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - CalendarColumn()

        /// <summary>
        /// 생성자
        /// </summary>
        public CalendarColumn() : base(new CalendarCell())
        {
        }

        #endregion
    }
}